/*
/--------------------------------------------------------------------
|
|      $Id: FilterIntensity.h,v 1.1 2000/11/06 23:20:22 uzadow Exp $
|
|      Copyright (c) 1996-1998 Ulrich von Zadow
|
\--------------------------------------------------------------------
*/

#if !defined(INCL_FILTERINTENSITY)
#define INCL_FILTERINTENSITY

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Filter.h"

class CBmp;

//! Changes the intensity of a bitmap image. 
//! Applies the factor intensityFactor = 1.0 + csupp * pow((v-m_offset), m_exponent)
//! with csupp = intensity/pow(255.0, m_exponent);
//! on the v-Value of the image after a HSV transform (who is going to write 
//! a HSV2RGB() transform in Assembler?).
//! The bitmap stays unchanged for intensity = 20, offset = 128, exponent = 1.
class CFilterIntensity : public CFilter  
{
public:
	CFilterIntensity (double intensity, BYTE offset, double exponent);
	virtual ~CFilterIntensity();
  virtual void Apply(CBmp *pBmpSource, CBmp* pBmpDest);

protected:
  double m_intensity;
  double m_offset;
  double m_exponent;
};
#endif

/*
/--------------------------------------------------------------------
|
|      $Log: FilterIntensity.h,v $
|      Revision 1.1  2000/11/06 23:20:22  uzadow
|      Added Contrast, Intensity and Lightness filters by
|      Thomas Hirschmann
|
|
\--------------------------------------------------------------------
*/
