/*
/--------------------------------------------------------------------
|
|      $Id: FilterLightness.h,v 1.3 2001/01/12 23:29:38 uzadow Exp $
|
|      Copyright (c) 1996-1998 Ulrich von Zadow
|
\--------------------------------------------------------------------
*/

#if !defined(INCL_FILTERLIGHTNESS)
#define INCL_FILTERLIGHTNESS

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Filter.h"

class CBmp;

//! Filter that changes the lightness of a bitmap image. lightness
//! values must be in the range -100..100. A value of 0 leaves the 
//! image unchanged.
class CFilterLightness : public CFilter  
{
public:
  //!
	CFilterLightness (int lightness);
  
  //!
	virtual ~CFilterLightness();

  //!
  virtual void Apply(CBmp *pBmpSource, CBmp* pBmpDest);

protected:
    double m_lightness;
};
#endif

/*
/--------------------------------------------------------------------
|
|      $Log: FilterLightness.h,v $
|      Revision 1.3  2001/01/12 23:29:38  uzadow
|      Lightness 0 now means "don't change anything".
|
|      Revision 1.2  2000/12/04 23:57:13  uzadow
|      Cleaned up code.
|
|
|
\--------------------------------------------------------------------
*/
