/*
/--------------------------------------------------------------------
|
|      $Id: FilterThreshold.h,v 1.1 2000/09/26 14:28:47 Administrator Exp $
|   
|
\--------------------------------------------------------------------
*/

#if !defined(INCL_FILTERTHRESHOLD)
#define INCL_FILTERTHRESHOLD

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Filter.h"

class CBmp;

//! Returns an 8 bpp grayscale bitmap that contains only the channel
//! selected and is black wherever this channel has values <= threshold_min
//! or >= threshold_max.
class CFilterThreshold : public CFilter
{
public:
  //! 
	CFilterThreshold(int threshold_min,int threshold_max, int channel);
  //! 
	virtual ~CFilterThreshold();

  //! 
  virtual void Apply(CBmp * pBmpSource, CBmp * pBmpDest);

protected:
	int m_threshold_min;
	int m_threshold_max;
	int m_channel;


};

#endif

/*
/--------------------------------------------------------------------
|
|      $Log: FilterThreshold.h,v $
|      Revision 1.1  2000/09/26 14:28:47  Administrator
|      Added Threshold filter
|
|
|
\--------------------------------------------------------------------
*/
