/*
|
|      $Id: memsink.cpp,v 1.1 2000/10/12 21:57:26 uzadow Exp $
|      Memory "Data Sink" Class
|
|      This class uses memory as a destination for picture data.
|
|      Copyright (c) 1996-1998 Ulrich von Zadow
|
\--------------------------------------------------------------------
*/

#include "stdpch.h"

#include "memsink.h"
#include "except.h"


CMemSink::CMemSink ()
{
  m_pFile = NULL;
}

CMemSink::~CMemSink ()
{
  if (m_pFile)
    Close();
}

int CMemSink::Open (const char * pszFName, int MaxFileSize)
{
  if (m_pDataBuf = new BYTE [MaxFileSize])
  {
    CDataSink::Open(pszFName, m_pDataBuf, MaxFileSize);
    return 0;
  }
  else
    return -1;
}

void CMemSink::Close ()
{
  if (m_pDataBuf)
  {
    delete m_pDataBuf;
    m_pDataBuf = NULL;
  }
}

BYTE* CMemSink::GetBytes()
{
	return m_pDataBuf;
}


/*
/--------------------------------------------------------------------
|
|      $Log: memsink.cpp,v $
|      Revision 1.1  2000/10/12 21:57:26  uzadow
|      no message
|
|
|
\--------------------------------------------------------------------
*/
