/*
/--------------------------------------------------------------------
|
|      $Id: pltester.h,v 1.7 2000/12/18 22:42:53 uzadow Exp $
|
|      Copyright (c) 1996-1998 Ulrich von Zadow
|
\--------------------------------------------------------------------
*/

#ifndef INCL_PLTESTER
#define INCL_PLTESTER

#ifdef _WINDOWS
#include <windows.h>
#else
#include "paintlibdefs.h"
#endif

#include "bitmap.h"
#include "anybmp.h"

#ifdef _WINDOWS
#include "DIBSect.h"
// #include "ddrawbmp.h"
#endif

class CPicEncoder;
class CPicDecoder;
class CFilter;
class CPLTester
{

public:
  CPLTester ();

  virtual ~CPLTester();


  void RunTests ();

private:
  void testCBmp (CBmp& Bmp);
#ifdef _WINDOWS
  void testCWinBmp (CWinBmp& Bmp);
  void testLoadRes ();
  void testDIBSect (CDIBSection& Bmp);
#endif
  void testCodec (const CPicEncoder& Encoder, const CPicDecoder& Decoder);
  void testCodecBmp (CBmp& Bmp, const CPicEncoder& Encoder, 
                     const CPicDecoder& Decoder, char * pszFName);
  void testCTIFFEx (CBmp& Bmp);

  void testFilters ();
  void testFilter (const CFilter& Filter);
  void testQuant (int DthPal, int Dth);

  void setUpBmp (CBmp& Bmp, int BPP);
  void setUp ();
  void tearDown ();
  void dumpBmp (CBmp& bmp);
  bool almostEqual (CBmp& bmp1, CBmp& bmp2, int epsilon);
  void test (bool b);

  
  CAnyBmp m_AnyBmp8;
  CAnyBmp m_AnyBmp32;

#ifdef _WINDOWS
  CDIBSection m_DIBSect8;
  CDIBSection m_DIBSect32;
#endif
//  CDDrawBmp m_DDBmp8;
//  CDDrawBmp m_DDBmp32;
};

#endif
/*
/--------------------------------------------------------------------
|
|      $Log: pltester.h,v $
|      Revision 1.7  2000/12/18 22:42:53  uzadow
|      Replaced RGBAPIXEL with CPixel32.
|
|      Revision 1.6  2000/12/09 12:16:26  uzadow
|      Fixed several memory leaks.
|
|      Revision 1.5  2000/12/04 23:59:02  uzadow
|      Added filter tests.
|
|      Revision 1.4  2000/12/03 21:15:43  uzadow
|      Fixed png handling in configure; test/ adapted to linux
|
|      Revision 1.3  2000/12/02 19:42:30  uzadow
|      Added CTIFFEncoderEx test.
|
|      Revision 1.2  2000/11/21 23:28:53  uzadow
|      Moved CBmp tests from testdec to test.
|
|      Revision 1.1  2000/11/21 20:29:39  uzadow
|      Added test project.
|
|
\--------------------------------------------------------------------
*/
