/*
/--------------------------------------------------------------------
|
|      $Id: StreamSink.cpp,v 1.1 2000/09/01 14:19:46 Administrator Exp $
|      Copyright (c) 1996-2000 Ulrich von Zadow
|
\--------------------------------------------------------------------
*/

#include "stdpch.h"
#include "ole2.h"
#include "StreamSink.h"

CStreamSink::CStreamSink()
{
  m_pDataBuf = NULL;
  m_pIStream = NULL;
  m_hMem = 0;
}

CStreamSink::~CStreamSink()
{
  if (m_pDataBuf)
  {
    GlobalUnlock(m_hMem);
    m_pDataBuf = NULL;
  }

  if (m_hMem)
  {
    m_hMem = GlobalFree(m_hMem);
  }

  if (m_pIStream)
  {
    m_pIStream->Release();
    m_pIStream = NULL;
  }
}

int CStreamSink::Open (int MaxFileSize)
{
	// Create the stream
	m_hMem = GlobalAlloc(GMEM_MOVEABLE, MaxFileSize);
  if (m_hMem == 0)
    throw CTextException (ERR_NO_MEMORY, "CStreamSink::Open - Error allocating memory.\n");

  if ((m_pDataBuf = (BYTE*)GlobalLock(m_hMem))==NULL)
    throw CTextException (ERR_INTERNAL, "CStreamSink::Open - Error locking memory.\n");
  CDataSink::Open("HGlobalStream", m_pDataBuf, MaxFileSize);
  return 0;

/*
  if ((CreateStreamOnHGlobal(hMem, TRUE, &m_pIStream) == S_OK) &&
    (m_pDataBuf = new BYTE [MaxFileSize]))
  {
    CDataSink::Open("HGlobalStream", m_pDataBuf, MaxFileSize);
    return 0;
  }
  else
    throw CTextException (ERR_INTERNAL, "Error creating HGlobalStream.\n");
*/
}

// now flush the data to the stream
void CStreamSink::Close ()
{
  GlobalUnlock(m_hMem);
  m_pDataBuf = NULL;

  // by setting fDeleteOnRelease to TRUE the stream owns the global memory block
  // and we don't have to call GlobalUnalloc.
  // So we can safely set m_hMem to 0.
  if (CreateStreamOnHGlobal(m_hMem, TRUE, &m_pIStream) != S_OK)
    throw CTextException (ERR_INTERNAL, "Error creating HGlobalStream.\n");
  m_hMem = 0;

  // Truncate the stream
  ULARGE_INTEGER uli_size; // Size of the written data, not of the author of paintlib
  uli_size.LowPart = GetDataSize();
  uli_size.HighPart = 0;
  m_pIStream->SetSize(uli_size);

  // reset pointer to beginning of stream
  LARGE_INTEGER li_NULL;
  li_NULL.LowPart = 0;
  li_NULL.HighPart = 0;
  m_pIStream->Seek(li_NULL,STREAM_SEEK_SET,NULL);
  CDataSink::Close();
}


IStream * CStreamSink::GetIStream()
{
  return m_pIStream;
}

/*
/--------------------------------------------------------------------
|
|      $Log: StreamSink.cpp,v $
|      Revision 1.1  2000/09/01 14:19:46  Administrator
|      no message
|
|
\--------------------------------------------------------------------
*/
