/*
/--------------------------------------------------------------------
|
|      $Id: dibgrit.h,v 1.4 2000/08/13 12:11:44 Administrator Exp $
|      Bitmap Graphic item class
|
|      A bitmap on a canvas.
|
|      Copyright (c) 1996-1998 Ulrich von Zadow
|
\--------------------------------------------------------------------
*/

#ifndef INCL_DIBGRIT
#define INCL_DIBGRIT

#include "gritem.h"

class CBmp;

class CDIBGrItem : public CGrItem
{

DECLARE_DYNAMIC (CDIBGrItem);

public:
  CDIBGrItem
    ( int x,            // Position on the canvas
      int y,
      int w,            // Width
      int h,            // Height
      int z,            // Position in z-Order
      BYTE Opacity,     // Opacity of the object. 255 is completely
                        // opaque, 0 is completely transparent.
      CBmp * pBmp       // The bitmap.
    );

  ~CDIBGrItem
    ();

  virtual void Draw
    ( CBmp * pCanvas,
      CRect * pUpdateRect
    );
    // Responsible for drawing the object on the canvas.

  CBmp * GetBmp
    ()
  {
    return m_pBmp;
  }

private:
  void drawClippedNoScale
    ( CBmp * pCanvas,
      CRect * pRect
    );
    // Draws the object. pRect must have been clipped already.
    // Assumes that no scaling is nessesary.

  void drawAlphaLine
    ( BYTE * pDest,
      BYTE * pSrc,
      CRect * pRect
    );

  void drawFadeLine
    ( BYTE * pDest,
      BYTE * pSrc,
      CRect * pRect
    );

  void drawClipped
    ( CBmp * pCanvas,
      CRect * pRect
    );

  void drawClippedNoAlpha
    ( CBmp * pCanvas,
      CRect * pRect
    );

  // Member variables.

  CBmp * m_pBmp;
};

#endif
/*
/--------------------------------------------------------------------
|
|      $Log: dibgrit.h,v $
|      Revision 1.4  2000/08/13 12:11:44  Administrator
|      Added experimental DirectDraw-Support
|
|      Revision 1.3  2000/01/16 20:43:19  anonymous
|      Removed MFC dependencies
|
|
\--------------------------------------------------------------------
*/
